//+------------------------------------------------------------------+

#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrLime
#property indicator_color2  clrMagenta
#property indicator_color3  clrNavy
#property indicator_color4  clrMaroon
#property indicator_color5  clrDarkOrange
#property indicator_color6  clrBlue
#property indicator_color7  clrRed
#property indicator_width3  20
#property indicator_width4  20
#property indicator_width6  5
#property indicator_width7  5

//
//
//
//
//
//AHTF Timeframe template copy and paste start11
enum enTimeFrames
{
   tf_cu  = PERIOD_CURRENT, // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mn1 = PERIOD_MN1,     // Monthly
   tf_n1  = -1,             // First higher time frame
   tf_n2  = -2,             // Second higher time frame
   tf_n3  = -3              // Third higher time frame
};
//AHTF Timeframe template copy and paste end11

//AHTF Timeframe template copy and paste start12
enTimeFrames      TimeFrame       = tf_cu;           // Time frame
//AHTF Timeframe template copy and paste end12

extern int    Tenkan                     = 9;                // Tenkan Period
extern int    Kijun                      = 26;               // Kijun Period
extern int    Senkou                     = 52;               // Senkou Period
extern bool   ShowZones                  = false;             // Display the background zones
extern color  ColorUp                    = clrLavender;      // Uptrend Zone color
extern color  ColorDown                  = clrLavenderBlush; // Downtrend Zone color
extern string UniqueZoneID               = "KumoZones2";     // Unique ID for the zones
extern bool   alertsOn                   = false;            // Alerts On?
extern bool   alertsOnKumoCloudCross     = false;            // Alerts on leaving Kumo cloud?
extern bool   alertsOnTenkanKijunCross   = false;            // Alerts on tenkan and kijun cross?
extern bool   alertsOnPriceKijunCross    = false;            // Alerts on price crossing kijun?
extern bool   alertsOnChinkouTenkanCross = false;            // Alerts on Chinkou and Tenkan cross?
extern bool   alertsOnSpanASpanBCross    = true;            // Alerts on SpanA and SpanB cross?
extern bool   alertsOnCurrent            = false;            // Alerts on current open bar?
extern bool   alertsMessage              = true;            // Alerts message?
extern bool   alertsSound                = true;            // Alerts sound?
extern bool   alertsNotify               = false;            // Alerts Send Notification?
extern bool   alertsEmail                = false;            // Alerts send email?

input bool            arrowsVisible             = true;              // Arrows visible true/false?
input string          arrowsIdentifier          = " RSI1";     // Unique ID for arrows
input bool            arrowsOnNewest            = false;
input double          arrowsUpperGap            = 1;                // Upper arrow gap
input double          arrowsLowerGap            = 0.5;                // Lower arrow gap
input color           arrowsUpColor             = clrYellow;       // Up arrow color
input color           arrowsDnColor             = clrYellow;          // Down arrow color
input int             arrowsUpCode              = 233;                // Up arrow code
input int             arrowsDnCode              = 234;                // Down arrow code
input int             arrowsUpSize              = 2;                  // Up arrow size
input int             arrowsDnSize              = 2;                  // Down arrow size

extern bool   Interpolate                = true;             // Interpolate values if multi timeframe is used

extern bool   Draw_Tenkan                = false;            // Draw Tenkan option
extern bool   Draw_Kijun                 = false;            // Draw Kijun option
extern bool   Draw_Kumo                  = true;            // Draw Kumo cloud option
extern bool   Draw_Chikou                = false;            // Draw Chinkou option

extern int    Length                 = 20;
extern ENUM_APPLIED_PRICE Price      = PRICE_CLOSE;
extern double RSIModifier            = 0.9;
extern double LevelUp                =  1;
extern double LevelDown              = -1;
extern double SmoothLength           =   5;
extern double SmoothPhase            =   0; 


//Forex-Station Zone template copy and paste start 1
double Dummy = -1;
//Forex-Station Zone template copy and paste end 1
double rsi[],trenda[];
double Tenkan_Buffer[], Kijun_Buffer[], SpanA_Buffer[], SpanB_Buffer[], Chinkou_Buffer[], SpanA2_Buffer[], SpanB2_Buffer[];
double trend1[], trend2[], trend3[], trend4[], trend5[], count[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,ShowZones,ColorUp,ColorDown,UniqueZoneID,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsIdentifier,arrowsOnNewest,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,Interpolate,Draw_Tenkan,Draw_Kijun,Draw_Kumo,Draw_Chikou,Length,Price,RSIModifier,LevelUp,LevelDown,SmoothLength,SmoothPhase,_buff,_ind)

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(14);
   SetIndexBuffer(0, Tenkan_Buffer);                                  SetIndexLabel(0,"Tenkan Sen");
   SetIndexBuffer(1, Kijun_Buffer);                                   SetIndexLabel(1,"Kijun Sen");
   SetIndexBuffer(2, SpanA_Buffer);  SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"Kumo Cloud"); 
   SetIndexBuffer(3, SpanB_Buffer);  SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"Kumo Cloud"); 
   SetIndexBuffer(4, Chinkou_Buffer);                                 SetIndexLabel(4,"Chinkou Span");
   SetIndexBuffer(5, SpanA2_Buffer);                                  SetIndexLabel(5,"Senkou Span A");
   SetIndexBuffer(6, SpanB2_Buffer);                                  SetIndexLabel(6,"Senkou Span B");
    SetIndexBuffer(7,rsi);
   SetIndexBuffer(8, trend1); 
   SetIndexBuffer(9, trend2); 
   SetIndexBuffer(10, trend3); 
   SetIndexBuffer(11,trend4); 
   SetIndexBuffer(12,trend5); 
   SetIndexBuffer(13,count);
   
   if (!Draw_Tenkan) SetIndexStyle(0, DRAW_NONE);
   if (!Draw_Kijun)  SetIndexStyle(1, DRAW_NONE);
   if (!Draw_Chikou) SetIndexStyle(4, DRAW_NONE);
   if (!Draw_Kumo) 
   {
      SetIndexStyle(2, DRAW_NONE);
      SetIndexStyle(3, DRAW_NONE);
      SetIndexStyle(5, DRAW_NONE);
      SetIndexStyle(6, DRAW_NONE);
   }
   
     //
     //
     //
     //
     //
     
     indicatorFileName = WindowExpertName();
     
//AHTF Timeframe Timeframe template copy and paste start13
   TimeFrame         = (enTimeFrames)timeFrameValue(TimeFrame);
//AHTF Timeframe Timeframe template copy and paste end13

     SetIndexShift(2,Kijun  * TimeFrame/Period()); 
     SetIndexShift(3,Kijun  * TimeFrame/Period());
     SetIndexShift(4,-Kijun * TimeFrame/Period());
     SetIndexShift(5,Kijun  * TimeFrame/Period());
     SetIndexShift(6,Kijun  * TimeFrame/Period());    
     
     //
     //
     //
      Length = fmax(Length ,1);
     //
      string PriceType;
         switch(Price)
         {
            case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
            case PRICE_OPEN:     PriceType = "Open";     break;  // 1
            case PRICE_HIGH:     PriceType = "High";     break;  // 2
            case PRICE_LOW:      PriceType = "Low";      break;  // 3
            case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
            case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
            case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
         }      
         
     //
      SetLevelValue(0,LevelUp);
      SetLevelValue(1,LevelDown);
     //
     //
     
     IndicatorShortName(timeFrameToString(TimeFrame)+" Ichimoku"); 
return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//AHTF Timeframe template copy and paste start14
int timeFrameValue(int _tf)
{
   int add  = (_tf>=0) ? 0 : MathAbs(_tf);
   if (add != 0) _tf = _Period;
   int size = ArraySize(iTfTable); 
      int i =0; for (;i<size; i++) if (iTfTable[i]==_tf) break;
                                   if (i==size) return(_Period);
                                                return(iTfTable[(int)MathMin(i+add,size-1)]);
}
//AHTF Timeframe template copy and paste end14
//+------------------------------------------------------------------------------------------------------------------+

//Forex-Station Zone template copy and paste start 2
//+------------------------------------------------------------------------------------------------------------------+
int deinit()
{
  deleteArrows();  
   string lookFor       = UniqueZoneID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   GlobalVariableDel(ChartID()+":"+UniqueZoneID);
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
//Forex-Station Zone template copy and paste end 2

int start()
{
   int i,k,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(Bars-counted_bars,Bars-1); count[0]=limit;

//Forex-Station Zone template copy and paste start 3
         datetime tDummy = GlobalVariableGet(ChartID()+":"+UniqueZoneID); if (tDummy==0) tDummy = Time[0];
//Forex-Station Zone template copy and paste end 3

            if (TimeFrame!=_Period)
            {
               limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(12,0)*TimeFrame/_Period));
               for (i=limit;i>=0 && !_StopFlag; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     Tenkan_Buffer[i]  = _mtfCall(0,y);
                     Kijun_Buffer[i]   = _mtfCall(1,y);
                     SpanA_Buffer[i]   = _mtfCall(2,y);
                     SpanB_Buffer[i]   = _mtfCall(3,y);
                     Chinkou_Buffer[i] = _mtfCall(4,y);
                     SpanA2_Buffer[i]  = _mtfCall(5,y);
                     SpanB2_Buffer[i]  = _mtfCall(6,y);
                     rsi[i]  = _mtfCall(7,y);
                     //
                     //
                     //
                     //
                     //
                     
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                        #define _interpolate(buff) buff[i+j] = buff[i]+(buff[i+n]-buff[i])*j/n
                        int n,j; datetime time = iTime(NULL,TimeFrame,y);
                           for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                           for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++) 
                           {
                              _interpolate(Tenkan_Buffer);
                              _interpolate(Kijun_Buffer);
                              _interpolate(SpanA_Buffer);
                              _interpolate(SpanB_Buffer);
                              _interpolate(Chinkou_Buffer);
                              _interpolate(SpanA2_Buffer);
                              _interpolate(SpanB2_Buffer);
                          }                           
//Forex-Station Zone template copy and paste start 5
            GlobalVariableSet(ChartID()+":"+UniqueZoneID,Time[0]+_Period*60-1);
//Forex-Station Zone template copy and paste end 5
                }
      return(0);
      }
      
      //
      //
      //
      //
      //
      
     for(i=limit; i>=0; i--)
     {
        double thi    = High[i];
        double tlo    = Low[i];
        double tprice = 0;
        if (i >= Bars - Tenkan) continue;
        for(k = 0; k < Tenkan; k++)
        {
           tprice = High[i+k]; if(thi<tprice) thi = tprice;
           tprice =  Low[i+k]; if(tlo>tprice) tlo = tprice;
        }
       
        if ((thi+tlo) > 0.0) 
             Tenkan_Buffer[i] = (thi + tlo)*0.5; 
        else Tenkan_Buffer[i] = 0;
       
        //
        //
        //
        //
        //
        
        double khi    = High[i];
        double klo    = Low[i];
        double kprice = 0;
        if  (i >= Bars - Kijun) continue;
        for (k = 0; k < Kijun; k++)
        {
           kprice = High[i+k]; if(khi<kprice) khi = kprice;
           kprice =  Low[i+k]; if(klo>kprice) klo = kprice;
        }
        
        if ((khi+klo) > 0.0) 
             Kijun_Buffer[i] = (khi + klo)*0.5; 
        else Kijun_Buffer[i] = 0;
       
        //
        //
        //
        //
        //
        
        double shi    = High[i];
        double slo    = Low[i];
        double sprice = 0;
        if  (i >= Bars - Senkou) continue;
        for (k = 0; k < Senkou; k++)
        {
           sprice = High[i+k]; if(shi<sprice) shi  = sprice;
           sprice =  Low[i+k]; if(slo>sprice) slo  = sprice;
        }
       
        //
        //
        //
        //
        //
        
        SpanA_Buffer[i]   = (Kijun_Buffer[i] + Tenkan_Buffer[i])*0.5;
        SpanA2_Buffer[i]  = (Kijun_Buffer[i] + Tenkan_Buffer[i])*0.5;
        SpanB_Buffer[i]   = (shi + slo)*0.5; 
        SpanB2_Buffer[i]  = (shi + slo)*0.5; 
        Chinkou_Buffer[i] = Close[i]; 
        rsi[i] = iSmooth(RSIModifier*(iRSI(NULL,0,Length,Price,i)-50.0),SmoothLength,SmoothPhase,i);
        if (i<Bars-1)
        {
           trend1[i] = trend1[i+1];
           trend2[i] = trend2[i+1];
           trend3[i] = trend3[i+1];
           trend4[i] = trend4[i+1];
           trend5[i] = trend5[i+1];
              if (Close[i] > MathMax(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun])) trend1[i] = 1;
              if (Close[i] < MathMin(SpanA_Buffer[i+Kijun],SpanB_Buffer[i+Kijun])) trend1[i] =-1;
              if (Tenkan_Buffer[i]>Kijun_Buffer[i])                                trend2[i] = 1;
              if (Tenkan_Buffer[i]<Kijun_Buffer[i])                                trend2[i] =-1;
              if (Close[i]>Kijun_Buffer[i])                                        trend3[i] = 1;
              if (Close[i]<Kijun_Buffer[i])                                        trend3[i] =-1;
              if (Chinkou_Buffer[i]<Tenkan_Buffer[i])                              trend4[i] = 1;
              if (Chinkou_Buffer[i]>Tenkan_Buffer[i])                              trend4[i] =-1;
              if (SpanA_Buffer[i]>SpanB_Buffer[i] && rsi[i]>LevelUp)                              trend5[i] = 1;
              if (SpanA_Buffer[i]<SpanB_Buffer[i] && rsi[i]<LevelUp)                             trend5[i] =-1;
        }
        if (arrowsVisible)
        {
            string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);            
            if (i<(Bars-1) && trend5[i] != trend5[i+1])
            {
              if (trend5[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
              if (trend5[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize, true);  
      }
       }
//Forex-Station Zone template copy and paste start 4
        if (trend5[i]==0 || !ShowZones) continue;

               for (int index=i; index<Bars; index++) if (trend5[index]!= trend5[index+1]) break;
               string name = UniqueZoneID+":"+Time[index+1]; ObjectDelete(name); ObjectDelete(UniqueZoneID+":"+Time[1]);
               
               datetime lastTime = Time[i-1]; if (i==0) { lastTime = tDummy; if (Time[index]==lastTime) lastTime = Time[0]+Period()*60;}
               ObjectCreate(name,OBJ_RECTANGLE,0,Time[index],0,lastTime,WindowPriceMax()*3.0);
                  ObjectSet(name,OBJPROP_BACK,true);
                  if (trend5[i]==-1)
                        ObjectSet(name,OBJPROP_COLOR,ColorDown);
                  else  ObjectSet(name,OBJPROP_COLOR,ColorUp);
//Forex-Station Zone template copy and paste end 4
       

   }
  manageAlerts();
  return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
    int whichBar = 1; if (alertsOnCurrent) whichBar = 0;          
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnKumoCloudCross && trend1[whichBar] != trend1[whichBar+1])
      {
         if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar,"Price crossing Kumo up");
         if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar,"Price crossing Kumo down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnTenkanKijunCross && trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar,"Tenkan crossing Kijun up");
         if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar,"Tenkan crossing Kijun down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnPriceKijunCross && trend3[whichBar] != trend3[whichBar+1])
      {
         if (trend3[whichBar] ==  1) doAlert(time3,mess3,whichBar,"Price crossing Kijun up");
         if (trend3[whichBar] == -1) doAlert(time3,mess3,whichBar,"Price crossing Kijun down");
      }
      static datetime time4 = 0;
      static string   mess4 = "";
      if (alertsOnChinkouTenkanCross && trend4[whichBar] != trend4[whichBar+1])
      {
         if (trend4[whichBar] ==  1) doAlert(time4,mess4,whichBar,"Tenkan crossing Chinkou up");
         if (trend4[whichBar] == -1) doAlert(time4,mess4,whichBar,"Tenkan crossing Chinkou down");
      }
      static datetime time5 = 0;
      static string   mess5 = "";
      if (alertsOnSpanASpanBCross && trend5[whichBar] != trend5[whichBar+1])
      {
         if (trend5[whichBar] ==  1) doAlert(time5,mess5,whichBar,"SpanA crossing SpanB up");
         if (trend5[whichBar] == -1) doAlert(time5,mess5,whichBar,"SpanA crossing SpanB down");
      }
   }

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ichimoku ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ichimoku "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

void drawArrow(int i,color theColor,int theCode, int theSize, bool up)
{
   string name = arrowsIdentifier+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //

      datetime time = Time[i]; if (arrowsOnNewest) time += _Period*60-1;      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_WIDTH,    theSize);
         ObjectSet(name,OBJPROP_COLOR,    theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}